Loading...
Searching...
No Matches
Gudhi::coxeter_triangulation::Cell_complex< Out_simplex_map_ > Class Template Reference

A class that constructs the cell complex from the output provided by the class Gudhi::coxeter_triangulation::Manifold_tracing. More...

`#include <include/gudhi/Coxeter_triangulation/Cell_complex/Cell_complex.h>`

## Public Types

using | Simplex_handle = typename Out_simplex_map_::key_type
| Type of a simplex in the ambient triangulation. Is a model of the concept SimplexInCoxeterTriangulation.
using | Hasse_cell = Gudhi::Hasse_diagram::Hasse_diagram_cell<int, double, bool>
| Type of a cell in the cell complex. Always is Gudhi::Hasse_cell from the Hasse diagram module. The additional information is the boolean that is true if and only if the cell lies on the boundary.
using | Simplex_cell_map = std::map<Simplex_handle, Hasse_cell*, Simplex_comparator<Simplex_handle> >
| Type of a map from permutahedral representations of simplices in the ambient triangulation to the corresponding cells in the cell complex of some specific dimension.
using | Simplex_cell_maps = std::vector<Simplex_cell_map>
| Type of a vector of maps from permutahedral representations of simplices in the ambient triangulation to the corresponding cells in the cell complex of various dimensions.
using | Cell_simplex_map = std::map<Hasse_cell*, Simplex_handle>
| Type of a map from cells in the cell complex to the permutahedral representations of the corresponding simplices in the ambient triangulation.
using | Cell_point_map = std::map<Hasse_cell*, Eigen::VectorXd>
| Type of a map from vertex cells in the cell complex to the permutahedral representations of their Cartesian coordinates.

## Public Member Functions

void | construct_complex (const Out_simplex_map_ &out_simplex_map)
| Constructs the the cell complex that approximates an \(m\)-dimensional manifold without boundary embedded in the \( d \)-dimensional Euclidean space from the output of the class Gudhi::Manifold_tracing.
void | construct_complex (const Out_simplex_map_ &out_simplex_map, std::size_t limit_dimension)
| Constructs the skeleton of the cell complex that approximates an \(m\)-dimensional manifold without boundary embedded in the \(d\)-dimensional Euclidean space up to a limit dimension from the output of the class Gudhi::Manifold_tracing.
void | construct_complex (const Out_simplex_map_ &interior_simplex_map, const Out_simplex_map_ &boundary_simplex_map)
| Constructs the the cell complex that approximates an \(m\)-dimensional manifold with boundary embedded in the \( d \)-dimensional Euclidean space from the output of the class Gudhi::Manifold_tracing.
void | construct_complex (const Out_simplex_map_ &interior_simplex_map, const Out_simplex_map_ &boundary_simplex_map, std::size_t limit_dimension)
| Constructs the skeleton of the cell complex that approximates an \(m\)-dimensional manifold with boundary embedded in the \(d\)-dimensional Euclidean space up to a limit dimension from the output of the class Gudhi::Manifold_tracing.
std::size_t | intrinsic_dimension () const
| Returns the dimension of the cell complex.
const Simplex_cell_maps & | interior_simplex_cell_maps () const
| Returns a vector of maps from the cells of various dimensions in the interior of the cell complex of type Gudhi::Hasse_cell to the permutahedral representations of the corresponding simplices in the ambient triangulation.
const Simplex_cell_maps & | boundary_simplex_cell_maps () const
| Returns a vector of maps from the cells of various dimensions on the boundary of the cell complex of type Gudhi::Hasse_cell to the permutahedral representations of the corresponding simplices in the ambient triangulation.
const Simplex_cell_map & | interior_simplex_cell_map (std::size_t cell_d) const
| Returns a map from the cells of a given dimension in the interior of the cell complex of type Gudhi::Hasse_cell to the permutahedral representations of the corresponding simplices in the ambient triangulation.
const Simplex_cell_map & | boundary_simplex_cell_map (std::size_t cell_d) const
| Returns a map from the cells of a given dimension on the boundary of the cell complex of type Gudhi::Hasse_cell to the permutahedral representations of the corresponding simplices in the ambient triangulation.
const Cell_simplex_map & | cell_simplex_map () const
| Returns a map from the cells in the cell complex of type Gudhi::Hasse_cell to the permutahedral representations of the corresponding simplices in the ambient triangulation.
const Cell_point_map & | cell_point_map () const
| Returns a map from the vertex cells in the cell complex of type Gudhi::Hasse_cell to their Cartesian coordinates.
| Cell_complex (std::size_t intrinsic_dimension)
| Constructor for the class Cell_complex.

## Detailed Description

template<class Out_simplex_map_>
class Gudhi::coxeter_triangulation::Cell_complex< Out_simplex_map_ >

A class that constructs the cell complex from the output provided by the class Gudhi::coxeter_triangulation::Manifold_tracing.

The use and interfaces of this cell complex is limited to the Coxeter triangulation implementation.

Template Parameters

  Out_simplex_map_ | The type of a map from a simplex type that is a model of SimplexInCoxeterTriangulation to Eigen::VectorXd.

Examples
  cell_complex_from_basic_circle_manifold.cpp, manifold_tracing_custom_function.cpp, and manifold_tracing_flat_torus_with_boundary.cpp.

## Constructor & Destructor Documentation

## Cell_complex()

template<class Out_simplex_map_>

Gudhi::coxeter_triangulation::Cell_complex< Out_simplex_map_ >::Cell_complex | ( | std::size_t | intrinsic_dimension | ) |

inline

Constructor for the class Cell_complex.

Parameters

  [in] | intrinsic_dimension | The dimension of the cell complex.

## Member Function Documentation

## boundary_simplex_cell_map()

template<class Out_simplex_map_>

const Simplex_cell_map & Gudhi::coxeter_triangulation::Cell_complex< Out_simplex_map_ >::boundary_simplex_cell_map | ( | std::size_t | cell_d | ) | const

inline

Returns a map from the cells of a given dimension on the boundary of the cell complex of type Gudhi::Hasse_cell to the permutahedral representations of the corresponding simplices in the ambient triangulation.

Parameters

  [in] | cell_d | The dimension of the cells.

## construct_complex() [1/4]

template<class Out_simplex_map_>

void Gudhi::coxeter_triangulation::Cell_complex< Out_simplex_map_ >::construct_complex | ( | const Out_simplex_map_ & | interior_simplex_map,
|  | const Out_simplex_map_ & | boundary_simplex_map )

inline

Constructs the the cell complex that approximates an \(m\)-dimensional manifold with boundary embedded in the \( d \)-dimensional Euclidean space from the output of the class Gudhi::Manifold_tracing.

Parameters

  [in] | interior_simplex_map | A map from simplices of dimension \((d-m)\) in the ambient triangulation that intersect the relative interior of the manifold to the intersection points.
  [in] | boundary_simplex_map | A map from simplices of dimension \((d-m+1)\) in the ambient triangulation that intersect the boundary of the manifold to the intersection points.

## construct_complex() [2/4]

template<class Out_simplex_map_>

void Gudhi::coxeter_triangulation::Cell_complex< Out_simplex_map_ >::construct_complex | ( | const Out_simplex_map_ & | interior_simplex_map,
|  | const Out_simplex_map_ & | boundary_simplex_map,
|  | std::size_t | limit_dimension )

inline

Constructs the skeleton of the cell complex that approximates an \(m\)-dimensional manifold with boundary embedded in the \(d\)-dimensional Euclidean space up to a limit dimension from the output of the class Gudhi::Manifold_tracing.

Parameters

  [in] | interior_simplex_map | A map from simplices of dimension \((d-m)\) in the ambient triangulation that intersect the relative interior of the manifold to the intersection points.
  [in] | boundary_simplex_map | A map from simplices of dimension \((d-m+1)\) in the ambient triangulation that intersect the boundary of the manifold to the intersection points.
  [in] | limit_dimension | The dimension of the constructed skeleton.

## construct_complex() [3/4]

template<class Out_simplex_map_>

void Gudhi::coxeter_triangulation::Cell_complex< Out_simplex_map_ >::construct_complex | ( | const Out_simplex_map_ & | out_simplex_map | ) |

inline

Constructs the the cell complex that approximates an \(m\)-dimensional manifold without boundary embedded in the \( d \)-dimensional Euclidean space from the output of the class Gudhi::Manifold_tracing.

Parameters

  [in] | out_simplex_map | A map from simplices of dimension \((d-m)\) in the ambient triangulation that intersect the relative interior of the manifold to the intersection points.

Examples
  cell_complex_from_basic_circle_manifold.cpp, and manifold_tracing_flat_torus_with_boundary.cpp.

## construct_complex() [4/4]

template<class Out_simplex_map_>

void Gudhi::coxeter_triangulation::Cell_complex< Out_simplex_map_ >::construct_complex | ( | const Out_simplex_map_ & | out_simplex_map,
|  | std::size_t | limit_dimension )

inline

Constructs the skeleton of the cell complex that approximates an \(m\)-dimensional manifold without boundary embedded in the \(d\)-dimensional Euclidean space up to a limit dimension from the output of the class Gudhi::Manifold_tracing.

Parameters

  [in] | out_simplex_map | A map from simplices of dimension \((d-m)\) in the ambient triangulation that intersect the relative interior of the manifold to the intersection points.
  [in] | limit_dimension | The dimension of the constructed skeleton.

## interior_simplex_cell_map()

template<class Out_simplex_map_>

const Simplex_cell_map & Gudhi::coxeter_triangulation::Cell_complex< Out_simplex_map_ >::interior_simplex_cell_map | ( | std::size_t | cell_d | ) | const

inline

Returns a map from the cells of a given dimension in the interior of the cell complex of type Gudhi::Hasse_cell to the permutahedral representations of the corresponding simplices in the ambient triangulation.

Parameters

  [in] | cell_d | The dimension of the cells.

Examples
  cell_complex_from_basic_circle_manifold.cpp.

The documentation for this class was generated from the following file:

- include/gudhi/Coxeter_triangulation/Cell_complex/Cell_complex.h